/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
   SELOR - Servidor de Emails Livre Orientado a Regras                           
   Programado por Lucas Priori                                                   
   Versao: 1.00                                                                  
                                                                                 
   Linux - make linux                                                            
   FreeBSD - make freebsd                                                        
                                                                                 
  *******************************************************************            
  Selor e um agente MTA para troca de emails via protocolo SMTP                 
  Copyright (C) 2012,2013,2014  Lucas Priori                                     
                                                                                 
  This program is free software; you can redistribute it and/or                  
  modify it under the terms of the GNU General Public License                    
  as published by the Free Software Foundation; either version 2                 
  of the License, or (at your option) any later version.                         
                                                                                 
  This program is distributed in the hope that it will be useful,                
  but WITHOUT ANY WARRANTY; without even the implied warranty of                 
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                  
  GNU General Public License for more details.                                   
                                                                                 
  You should have received a copy of the GNU General Public License              
  along with this program; if not, write to the Free Software                    
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<time.h>
#include<fcntl.h>
#include<sys/stat.h>
#include<dirent.h>
#include<unistd.h>


#ifndef CONFFILE
 #define CONFFILE "/usr/local/selor/selor.conf"
#endif
#define CAM_spool "/var/spool/selor/"
#define TAM_buffer 4096
#define TAM_defs 500
#define SESSAO_global 0
#define SESSAO_dest 1

// Variaveis e estruturas
struct servs_tempo{
 char dia_semana[3];
 char fim1;
 char mes[3];
 char fim2;
 char dia[2];
 char fim3;
 char hora[2];
 char fim4;
 char minuto[2];
 char fim5;
 char segundo[2];
 char fim6;
 char ano[4];
 char fim7;
}infotempo;
struct cpl_struct{
 char *orig;
 char *dest;
 unsigned int tamusado;
 unsigned int tambuffer;
};
char DEF_queue_path[TAM_defs]=CAM_spool;
char buffer[TAM_buffer + 1];
char linha[TAM_buffer + 1];
char ret_buffer[100]={0};

// Funcoes em Assembly 
//---------------------------------------------------------------------
extern char *pular_carac(char *string, int carac);
//---------------------------------------------------------------------
extern void str_arruma_crlf(char *string);
//---------------------------------------------------------------------
extern unsigned int selor_strncpy(char *destino, char *origem, unsigned int tam_str);
//---------------------------------------------------------------------
extern unsigned int selor_superstrncpy(char *destino, unsigned int tam_str, ...);      // Ultimo parametro DEVE ser sempre NULL
//---------------------------------------------------------------------
extern unsigned int selor_strncat(char *destino, char *origem, unsigned int tam_str);
//---------------------------------------------------------------------
extern char t_inject(char *str);
//---------------------------------------------------------------------
extern unsigned int conv_crlf(char *string1, char *string2, int num_bytes, char *ult_buffer);
//---------------------------------------------------------------------
extern int cmp_str(char *string1, char *string2, int num_bytes);
//---------------------------------------------------------------------
extern int cmp_str_vars(char *string1, char *string2);
//---------------------------------------------------------------------
extern unsigned int selor_segcp(char *destino, char *origem);
//---------------------------------------------------------------------
extern int cpl(struct cpl_struct *);
//---------------------------------------------------------------------

//=============================================
char *ret_detalhes(struct stat *dados_entr){
 char tam[50];
 
 memcpy(&infotempo, ctime(&dados_entr->st_ctime), sizeof(infotempo));
 infotempo.fim1=infotempo.fim2=infotempo.fim3=infotempo.fim4=infotempo.fim5=infotempo.fim6=infotempo.fim7=0;
 if(infotempo.dia[0] == ' ')infotempo.dia[0]='0';
 if(infotempo.mes[0] == 'J'){
  if(infotempo.mes[1] == 'a')strcpy(infotempo.mes, "01\0");
  else if(infotempo.mes[2] == 'n')strcpy(infotempo.mes, "06\0");
  else strcpy(infotempo.mes, "07\0");
 }else if(infotempo.mes[0] == 'M'){
  if(infotempo.mes[2] == 'r')strcpy(infotempo.mes, "03\0");
  else strcpy(infotempo.mes, "05\0");
 }else if(infotempo.mes[0] == 'A'){
  if(infotempo.mes[1] == 'p')strcpy(infotempo.mes, "04\0");
  else strcpy(infotempo.mes, "08\0");
 }else if(infotempo.mes[0] == 'F')strcpy(infotempo.mes, "02\0");
 else if(infotempo.mes[0] == 'S')strcpy(infotempo.mes, "09\0");
 else if(infotempo.mes[0] == 'O')strcpy(infotempo.mes, "10\0");
 else if(infotempo.mes[0] == 'N')strcpy(infotempo.mes, "11\0");
 else strcpy(infotempo.mes, "12\0");
 
 if(dados_entr->st_size < 1024){
  sprintf(tam,"%u Bytes",(unsigned int)dados_entr->st_size);
 }else if(dados_entr->st_size < 1048576){
  sprintf(tam,"%u KB",(unsigned int)dados_entr->st_size >> 10);  //   Dividido por 1024
 }else {
  sprintf(tam,"%u MB",(unsigned int)dados_entr->st_size >> 20);  //   Dividido por (1024 * 1024)
 }
 selor_superstrncpy(ret_buffer, 60, infotempo.ano, "-", infotempo.mes, "-",infotempo.dia, " ",infotempo.hora, ":",infotempo.minuto, ":",infotempo.segundo," (", tam, ")", NULL);
 
 return ret_buffer;
}

//=============================================
//            Programa principal               
//=============================================
int main(int argc, char *argv[]){
 FILE *arq_conf;
 DIR *dir;
 struct dirent *entr;
 struct stat dados_entr;
 struct cpl_struct arq_handler;
 char op_p=0;
 char op_e=0;
 char op_a=0;
 char op_sr=0;
 char op_i[50]={0};
 char op_q=0;
 char *ptr_aux1=NULL;
 char *ptr_aux2=NULL;
 char processing[12]="Processing\0";
 char waiting[9]="Waiting\0";
 char *modo=NULL;
 char sessao=SESSAO_global;
 char status_espera[7]="(   )\0";
 char status_erro[7]="( X )\0";
 char status_entregue[7]="( p )\0";
 char *status;
 char mostrar=0;
 int b_lidos=0;
 int arq_fila=0;
 unsigned int total_proc=0;
 unsigned int total_wait=0;
 unsigned int total_dests=0;
 unsigned int cont1=0;
 
 for(cont1=1; cont1<argc; cont1++){
  if(!strcmp(argv[cont1],"-p"))op_p=1;
  else if(!strcmp(argv[cont1],"-e"))op_e=1;
  else if(!strcmp(argv[cont1],"-a"))op_a=1;
  else if(!strcmp(argv[cont1],"-q"))op_q=1;
  else if(!strcmp(argv[cont1],"-sr"))op_sr=1;
  else if(!strcmp(argv[cont1],"-i")){
   cont1++;
   if(cont1 == argc){
    printf("Option '-i' requires a ID number.\n");
    goto Ajuda;
   }
   strcpy(op_i, argv[cont1]);
  }else {
   Ajuda:
   printf("\nOptions      | Description\n");
   printf(" -p            Show only processed IDs\n");
   printf(" -a            Show all recipients: delivered, pending and errors\n");
   printf(" -e            Show only recipients with errors\n");
   printf(" -q            Look in qlimit queue\n");
   printf(" -sr           Show responses of each recipient\n");
   printf(" -i <id file>  Show only this id message \n");
   printf("\nExample:\n");
   printf(" selorq -a\n");
   printf(" selorq -a -sr\n");
   printf(" selorq -e -sr\n");
   printf("\n");
   return 1;
  }
 }
 
 if(!(arq_conf=fopen(CONFFILE, "rb"))){
  printf("File not found [%s]\n", CONFFILE);
  return 1;
 }
 arq_handler.dest=linha;
 arq_handler.tambuffer=arq_handler.tamusado=TAM_buffer;
 while(!feof(arq_conf)){
  b_lidos=fread(&buffer, 1, TAM_buffer, arq_conf);
  buffer[b_lidos]=0;
  arq_handler.orig=buffer;
  while(!cpl(&arq_handler)){
   arq_handler.dest=linha;
   if(!cmp_str(linha, "Queue_path ", 11)){
    ptr_aux1=&linha[10];
    ptr_aux1=pular_carac(ptr_aux1, ' ');
    if(*ptr_aux1 == '"')ptr_aux1++;
    ptr_aux2=strchr(ptr_aux1, '"');
    if(ptr_aux2)*ptr_aux2=0;
    selor_strncpy(DEF_queue_path, ptr_aux1, TAM_defs);
    goto Campo_achado;
   }
  }
 }
 Campo_achado:
 fclose(arq_conf);
 if(op_q)selor_strncat(DEF_queue_path, "/qlimit", TAM_defs);
 if(!(dir=opendir(DEF_queue_path))){
  printf("Directory not found [%s]\n", DEF_queue_path);
  return 1;
 }
 printf("\nE-mails in: [%s]\n", DEF_queue_path);
 while((entr=readdir(dir))!=NULL){
  if(entr->d_name[0] == 'c'){
   ptr_aux1=buffer+selor_strncpy(buffer, DEF_queue_path, TAM_buffer);
   *ptr_aux1++='/';
   strcpy(ptr_aux1, entr->d_name);
   stat(buffer, &dados_entr);
   if(!(dados_entr.st_mode & S_IFDIR)){
    if(op_i[0] && strcmp(&entr->d_name[1], op_i))continue;
    // Arquivo de fila entrado
    *ptr_aux1='l';
    if((arq_fila=open(buffer, O_RDONLY)) > 0){
     if(lockf(arq_fila, F_TEST, 0) !=0){
      modo=processing;
      total_proc++;
     }else {
      modo=waiting;
      total_wait++;
     }
     printf("\n[%s] %s - %s\n", &entr->d_name[1], ret_detalhes(&dados_entr), modo);
     // Lendo arquivo de fila
     sessao=SESSAO_global;
     arq_handler.dest=linha;
     arq_handler.tambuffer=arq_handler.tamusado=TAM_buffer;
     do{
      b_lidos=read(arq_fila, buffer, TAM_buffer);
      buffer[b_lidos]=0;
      arq_handler.orig=buffer;
      while(!cpl(&arq_handler)){
       arq_handler.dest=linha;
       if(linha[0] == '[')sessao=SESSAO_dest;
       if(sessao == SESSAO_global){
        // == Sessao GLOBAL ==
        if(linha[0] == '<'){
         ptr_aux1=strchr(linha, '>');
         if(ptr_aux1){
          *ptr_aux1++=0;
          ptr_aux1=pular_carac(ptr_aux1, ' ');
          ptr_aux2=strchr(ptr_aux1, ' ');
          if(ptr_aux2)*ptr_aux2=0;
          printf("     From: <%s>   Attempts: %s", &linha[1], ptr_aux1);
         }else printf("     Invalid format at ID file %s\n", &entr->d_name[1]);
        }
       }else {
        // == Sessao Remetente ==
        ptr_aux1=linha;
        if(*ptr_aux1 == '['){
         mostrar=1;
         ptr_aux1++;
         if(*ptr_aux1 == '@' || *ptr_aux1 == '*'){
          status=status_entregue;
          if(!op_a && !op_p)mostrar=0;
         }else if(*ptr_aux1 == '!'){
          status=status_erro;
          if(!op_a && !op_e)mostrar=0;
         }else {
          status=status_espera;
          if(op_e || op_p)mostrar=0;
         }
         total_dests++;
         if(mostrar){
          ptr_aux1+=2;
          ptr_aux2=strchr(ptr_aux1,']');
          if(ptr_aux2){
           *ptr_aux2=0;
           printf("\n     %s to: %s", status, ptr_aux1);
          }else printf("     Invalid format at ID file %s\n", &entr->d_name[1]);
         }
        }else if(mostrar){
         if(op_sr && !strncmp(ptr_aux1, "Resp:", 5)){
          ptr_aux1+=5;
          printf("  %s", ptr_aux1);
         }
        }
       }
      }
     }while(b_lidos == TAM_buffer);
     close(arq_fila);
     printf("\n");
    }
   }
  }
 }
 printf("\nTotal messages: %d\nTotal dests: %d\nProcessing: %d\nWaiting: %d\n", total_proc+total_wait, total_dests, total_proc, total_wait);
 printf("---------------------------------\nLegend:\n (   ) Could not deliver yet\n ( p ) Processed\n ( X ) Error in delivery\n\n");
 closedir(dir);
 return 0;
}

